function widgetOnLoad()
{
  widget.WindowZPosition= 0x0FFFFFFF;
  widget.Width = container.Width = panel.Width = handle.Width = ScreenWidth;
  widget.Top = 0;
  widget.Left = 0;
  
  //set alignment
  volume.Left = Math.min(volbutton.Left-40,Screenwidth-80);
  net.Left = Math.min(netbutton.Left-70,Screenwidth-70);
  battery.Left = Math.min(batterybutton.Left-60,Screenwidth-60);
  user.Left = ScreenWidth - 230;
  settings.Left = user.Left-245;
  
  calendar.Left =  (ScreenWidth/2)-110;
  clock.Left =  (ScreenWidth/2)-30;

   if(FileExists(Shell.ExpandEnvironmentStrings("%TEMP%\\%USERNAME%.bmp")))
   avatar.Src = Shell.ExpandEnvironmentStrings("%TEMP%\\%USERNAME%.bmp");
   name.Text = LoginName;
   username.Text = LoginName;
   
  //user prefs
  //WidgetPath.a
  //widget.autoHideOnEdgeTop = GetValue("autohide",true);
  
  
}

/* Panel Components */

/*
Launcher Code
*/

Shell = new ActiveXObject("WScript.Shell");
FSO = new ActiveXObject("Scripting.FileSystemObject"); 
var folder1 = Shell.ExpandEnvironmentStrings("%USERPROFILE%")+"\\Desktop";
var folder2 = Shell.ExpandEnvironmentStrings("%PUBLIC%")+"\\Desktop";

title = "Applications";

var lc = GetValue("lastcount",-1);

//avoiding race conditions especially when desktop icons are large in number,
// update may be called but the previous call might not have completed.
var changing = false;

function timercore1OnUpdate(Sender)
{
     //detects if something is already cooking. Wait for it to complete.
     if(changing) return;
     //print("refreshing");
     thisc =  FSO.GetFolder(folder1).Files.Count + FSO.GetFolder(folder2).Files.Count;
     //print(thisc);
     
     if(thisc != lc)
     {
       //notify that we are busy!
       changing=true;
       lc = thisc;
       refreshIcons();
       Setvalue("lastcount",lc);
       //we're done
       changing=false;
       SaveIni();
     } 
}

function refreshIcons()
{
    /*
    Workaround a bug of shortcutlistcore not storing correct values when rapidly deleting icons.
    Shortcutlist1 apparently stores its data in the indexdb as ShortcutListCore(x).property format.
    Overriding the count property forces it to overwrite new entries in the db.
    
     */
    Setvalue("shortcutlistcore1.count",0); //fixme: dubious, if internal implementation changes,
                                           //the widget would be rendered useless
    SaveIni();
    
    //Refresh ShortcutListCore
    shortcutlistcore1.cmd(null,"!Refresh");
    
    //Add files
    list1 = GetFileList(folder1,"lnk",false);
    list2 = GetFileList(folder2,"lnk",false);
    
    //BUG: Avoid getting blank 'default' icon
    if(list1 != "")
    shortcutlistcore1.cmd(null,"!Add="+list1);

    if(list2 != "")
    shortcutlistcore1.cmd(null,"!Add="+list2);
    

}

//DnD for testing purposes only
/*function gridOnDragDrop(Sender,Data,Point)
{
    print("!Add="+Data);
    shortcutlistcore1.cmd(null,"!Add="+Data);
}  */

/* UI Functions */
function iconOnMouseEnter(Sender)
{
     Sender.Effect.Glow.Enabled = true;
     Title.Text = TitleCase(shortcutlistcore1.get("%"+Sender.Name.replace("icon","Item")+"_DisplayName"));
}

function iconOnMouseLeave(Sender)
{
    Sender.Effect.Glow.Enabled = false;
    Title.Text = title;
}

//Aahh! The old school days of programming beginning!
function TitleCase(text)
{
   array = text.split(" ");
   ret = "";
   for( elem in array)
   ret = ret.concat(array[elem].replace(array[elem].charAt(0),array[elem].charAt(0).toUpperCase())," ");
   
   return ret;
}

/* Calendar */
/* UI Ops */

function appbuttonOnClick(Sender)
{
  SlidePanelInOut(launcher);
}

function clockOnClick(Sender)
{
  SlidePanelInOut(calendar);
}

/* Volume Control Code */

/*function progressbar1OnMouseMove(Sender,Shift,X,Y,Dx,Dy)
{
    volumecore1.volume = progressbar1.percent;
}

function image1OnMouseWheel(Sender,Shift,WheelDelta)
{
  if(WheelDelta<0)
    volumecore1.volume = volumecore1.volume - 2
  else
    volumecore1.volume = volumecore1.volume + 2
  ;
  
}   */

function progressbar1OnMouseWheel(Sender,Shift,WheelDelta)
{
  volumecore1.volume = progressbar1.percent;
}

function volumecore1OnUpdate(Sender)
{ 
     tip.Top = 105-(Math.abs(95*progressbar1.Percent/100)-8);
     var val = volumecore1.get("%IsMute");
     var volume = volumecore1.get("%TenthVolume");
     if(volumecore1.get("%IsMute") == 'True')
     {
        volbutton.Src= WidgetPath+"volume-muted.png";
     }
     else if(volume >= 7)
     {
       volbutton.Src= WidgetPath+"volume-high.png";
     } else if(volume >= 4)
     {
       volbutton.Src= WidgetPath+"volume-medium.png";
     } else if(volume >= 1)
     {
       volbutton.Src= WidgetPath+"volume-low.png";
     } else
     {
       volbutton.Src= WidgetPath+"audio-volume-zero.png";
     }
}

/*  UI Functions */
function muteOnMouseEnter(Sender)
{
      mute.Background.Gradient.Enabled = true;
}

function muteOnMouseLeave(Sender)
{
     mute.Background.Gradient.Enabled = false;
}

function muteOnMouseDown(Sender,Button,Shift,X,Y)
{
    mute.Background.Gradient.StartColor = rgba(255,255,255,128);
    mute.Background.Gradient.StopColor = rgba(255,255,255,0);
}

function muteOnMouseUp(Sender,Button,Shift,X,Y)
{
    mute.Background.Gradient.StartColor = rgba(255,255,255,0);
    mute.Background.Gradient.StopColor = rgba(255,255,255,128);
}


function volbuttonOnClick(Sender)
{
  SlidePanelInOut(volume);
}

/* NetMonitor */
function netmonitorcore1OnUpdate(Sender)
{
    if(netmonitorcore1.get("%IPAddr") == "0.0.0.0")
    {
          netbutton.Src = "offline.png";
         //print("not connected");
    } else {
       netbutton.Src = "online.png";
    }
}

/* Battery */
function batterycore1OnUpdate(Sender)
{
  if(batterycore1.get("%Status") == "unknown") {
     //we're not (perhaps) using any sort of battery, disable the functions
     //print("no battery");
     batterybutton.Visible = false;
  }
}

/* UI Utility Functions */

/*
 * Safely Slides a panel in or out.
 */ 
function SlidePanelInOut(panel)
{
     //slide all panels back
     if(panel.Slided)
     {
     net.Slided = true;
     net.Visible = false;

     user.Slided = true;
     user.Visible = false;
     
     battery.Slided = true;
     battery.Visible = false;
     
     volume.Slided = true;
     volume.Visible = false;

     launcher.Slided = true;
     launcher.Visible = false;

     calendar.Slided = true;
     calendar.Visible = false;
     
     settings.Slided = true;
     settings.Visible=false;

     panel.Visible = true;
     widget.Height = panel.SlideValue+32;
     panel.slided = false;
     }else {
        panel.slided = true;
        sleep(300); //allow animation to complete
        panel.Visible = false;
        widget.Height = 32;
     }
}


function userOnClick(Sender)
{
   SlidePanelInOut(user);
}

function batterybuttonOnClick(Sender)
{
   SlidePanelInOut(battery);
}

function netbuttonOnClick(Sender)
{
   SlidePanelInOut(net);
}



function text3OnClick(Sender)
{
   if(settings.Slided)
   {
      settings.Visible=true;
      settings.Slided=false;
   }  else {
      settings.Slided=true;
      sleep(300);
      settings.Visible=false;
   }
}

function controlOnMouseEnter(Sender)
{

     control = eval(Sender.Name+"bg");
     control.Background.Gradient.Enabled=true;
     control.Background.Gradient.StopColor=rgba(0,74,113,255);
     control.Background.Gradient.StartColor=rgba(0,134,168,255);
}

function controlOnMouseDown(Sender,Button,Shift,X,Y)
{
         control = eval(Sender.Name+"bg");
         control.Background.Gradient.StartColor=rgba(0,74,113,255);
         control.Background.Gradient.StopColor=rgba(0,134,168,255);
}

function controlOnMouseLeave(Sender)
{
  control = eval(Sender.Name+"bg");
  control.Background.Gradient.Enabled=false;
}


function menuitem1OnClick(Sender)
{
  pop3mailcore1.cmd(null,"!Refresh");
  netmonitorcore1.cmd(null,"!Clear");
  refreshIcons();
}


function widgetOnEnter()
{
   container.Slided = false;
}

function widgetOnLeave()
{
   container.Slided = true;
}

function widgetOnAppDeactivate()
{
     net.Slided = true;
     net.Visible = false;

     user.Slided = true;
     user.Visible = false;

     battery.Slided = true;
     battery.Visible = false;

     volume.Slided = true;
     volume.Visible = false;

     launcher.Slided = true;
     launcher.Visible = false;

     calendar.Slided = true;
     calendar.Visible = false;
     
     settings.Slided = true;
     settings.Visible=false;
     
     widget.Height = 30;
}


function button1OnClick(Sender)
{
    WScript.Exec("shutdown /s /t 0");
}

function button3OnClick(Sender)
{
   EScript.Exec("shutdown /r /t 0");
}